`rbmp` <-
function(file, width=0, height=0, offset.x=0, offset.y=0) {
	if(width < 0)  { 
		warning("width must be > 0")
		return(NA)  
	}
	if(height < 0)  { 
		warning("height must be > 0")
		return(NA)  
	}
	
	if(offset.x < 0)  { 
		warning("offset must be > 0")
		return(NA)  
	}
	
	if(offset.y < 0)  { 
		warning("offset must be > 0")
		return(NA)  
	}
	
	if(identical(toString(file), ""))  {
		warning("missing filename")
		return(NA)
	}
	if(!file_test(op="-f", toString(file)))   {
		warning("file doesn't exist")
		return(c(0))
	}
		
	x<-.Call("rbmp", toString(file), as.integer(width), as.integer(offset.x), as.integer(height), as.integer(offset.y), PACKAGE="crackrec")
	return(matrix(unlist(x$matrix),nrow=x$width, byrow=T))
}

