`shadow.remove` <-
function(x) {
	if(!is.matrix(x))   {
		warning("No matrix\n")
		return(x)
	}
	dx.x<-dim(x)[1]
	dx.y<-dim(x)[2]
	if(dx.x < 80 || dx.y < 80)   {
		warning("Dimension of the matrix must be at least 80x80\n")
		return(x)
	}
	tmpvec<-1:40
	tmpvec.x<-1:dx.x
	tmpvec.y<-1:dx.y
	ml<-mean(x[1:40,])
	mr<-mean(x[(dx.x:(dx.x-40)),])
	mu<-mean(x[,1:40])
	mo<-mean(x[,dx.y:(dx.y-40)])
	mx<-mean(x[40:(dx.x-40),40:(dx.y-40)])
	by<-sum(exp((-1)*tmpvec^2/(30*dx.y)) + (1/4)*exp((-1)*tmpvec^2/dx.y))
	bx<-sum(exp((-1)*tmpvec^2/(30*dx.x)) + (1/4)*exp((-1)*tmpvec^2/dx.x))
	
	if(ml-10 < mr)   {  
		cat("shadow on the left hand side has been removed\n")
		while(ml < mx - 10)  {
			a<-(40*abs(ml - mx))/bx
			fshd<-function(wert) { wert + (a*exp((-1)*tmpvec.x^2/(30*dx.x))) + ((a/4)*exp((-1)*tmpvec.x^2/(dx.x)))  }
			x<-apply(x, 2, fshd)
			x[x>255]<-255
			ml<-mean(x[1:40,])
		}
	}
	if(mr - 10 < ml) { 
		cat("shadow on the right hand side has been removed\n")
		while(mr < mx - 10)  {
			a<-(40*abs(mr - mx))/bx
			fshd<-function(wert) { wert + (a*exp((-1)*(dx.x-tmpvec.x)^2/(30*dx.x))) + ((a/4)*exp((-1)*(dx.x-tmpvec.x)^2/(dx.x)))  }
			x<-apply(x, 2, fshd)
			x[x>255]<-255
			mr<-mean(x[(dx.x-40):dx.x,])
		}
	}
	if(mu-10 < mo)   {
		cat("shadow on the bottom has been removed\n")
		while(mu < mx - 10)  {
			a<-(40*abs(mu - mx))/by
			fshd<-function(wert) {  wert + (a*exp((-1)*tmpvec.y^2/(30*dx.y))) + ((a/4)*exp((-1)*tmpvec.y^2/(dx.y)))  }
			x<-t(apply(x, 1, fshd))
			x[x>255]<-255
			mu<-mean(x[,1:40])
		}
		
	}
	
	if(mo - 10 < mu) {
		cat("shadow on the top has been removed\n")
		while(mo < mx - 10)  {
			a<-(40*abs(mo - mx))/by
			fshd<-function(wert) { wert + (a*exp((-1)*(dx.y-tmpvec.y)^2/(30*dx.y))) + ((a/4)*exp((-1)*(dx.y-tmpvec.y)^2/(dx.y)))  }
			x<-t(apply(x, 1, fshd))
			x[x>255]<-255
			mo<-mean(x[,(dx.y-40):dx.y])
		}
	}
	
	return(x)
}

